-- ==========================================================
--
--              CHAPTER 5
--
-- ==========================================================


-- 1

SELECT     DISTINCT MakeName, Color
FROM       Data.Make AS MK
INNER JOIN Data.Model AS MD ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID	
WHERE      Color = 'Red' OR MakeName = 'Ferrari'


-- 2

SELECT DISTINCT  MakeName, Color
FROM             Data.Make AS MK	
INNER JOIN       Data.Model AS MD ON MK.MakeID = MD.MakeID
INNER JOIN       Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN       Data.SalesDetails SD ON ST.StockCode = SD.StockID
WHERE            Color = 'Red' AND MakeName = 'Ferrari'


-- 3

SELECT     DISTINCT MakeName, Color
FROM       Data.Make AS MK	
INNER JOIN Data.Model AS MD ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID	
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
WHERE      Color IN ('Red', 'Green', 'Blue') AND MakeName != 'Bentley'


-- 4

SELECT     DISTINCT ModelName, Color, PartsCost, RepairsCost
FROM       Data.Stock AS ST 	
INNER JOIN Data.Model AS MD	
           ON ST.ModelID = MD.ModelID
WHERE      Color = 'Red' AND (PartsCost > 1000 OR RepairsCost > 1000)


-- 5

SELECT DISTINCT  ModelName, Color, PartsCost, RepairsCost
FROM             Data.Stock AS ST 
INNER JOIN Data.Model AS MD
                 ON ST.ModelID = MD.ModelID
WHERE            (Color IN ('Red', 'Green', 'Blue') 
                   AND 		
                   ModelName = 'Phantom') 
                 OR 
                (PartsCost > 5500 AND RepairsCost > 5500)


-- 6

SELECT     CustomerName 
FROM       Data.Customer		
WHERE      CustomerName LIKE '%pete%'


-- 7

SELECT     CustomerName 
FROM       Data.Customer		
WHERE      CustomerName NOT LIKE '%pete%'


-- 8

SELECT DISTINCT   MD.ModelName, SA. InvoiceNumber
FROM              Data.Make AS MK 
INNER JOIN        Data.Model AS MD 
                  ON MK.MakeID = MD.MakeID
INNER JOIN        Data.Stock ST	
                  ON ST.ModelID = MD.ModelID
INNER JOIN        Data.SalesDetails AS SD 	
                  ON SD.StockID = ST.StockCode
INNER JOIN        Data.Sales AS SA
                  ON SA.SalesID = SD.SalesID
WHERE             InvoiceNumber LIKE '___FR%'


-- 9

SELECT   CustomerName
FROM     Data.Customer	
WHERE    PostCode IS NULL

