-- ==========================================================
--
--              CHAPTER 6
--
-- ==========================================================



-- 2

SELECT   MakeName, ModelName
         ,Cost + RepairsCost + PartsCost + TransportInCost AS TotalCost
FROM     Data.SalesByCountry


-- 4

SELECT   MakeName, ModelName
         ,SalePrice - (Cost + RepairsCost + PartsCost + TransportInCost) 
         AS GrossMargin	
FROM     Data.SalesByCountry 


-- 5

SELECT   (SalePrice - (Cost + RepairsCost + PartsCost + TransportInCost)) 
         / SalePrice AS RatioOfCostsToSales
FROM     Data.SalesByCountry	


-- 6

SELECT (SalePrice * 1.05) 
       - (Cost + RepairsCost + PartsCost + TransportInCost) 
       AS ImprovedSalesMargins
FROM   Data.SalesByCountry	


-- 7

SELECT TOP 50 MakeName
          ,(SalePrice - (Cost + RepairsCost + PartsCost + TransportInCost)) 
          / SalePrice AS Profitability 
FROM      Data.SalesByCountry 	
ORDER BY  Profitability DESC


-- 8

SELECT   MakeName, ModelName
         ,Cost + RepairsCost + ISNULL(PartsCost, 0)  + TransportInCost 
         AS TotalCost	
FROM     Data.SalesByCountry


-- 9

SELECT     DISTINCT MakeName, ModelName, SalePrice
FROM       Data.Make AS MK
INNER JOIN Data.Model AS MD ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
WHERE      SalePrice - 		
             (Cost + RepairsCost + PartsCost + TransportInCost) > 5000


-- 10

SELECT     DISTINCT MakeName, ModelName
FROM       Data.Make AS MK
INNER JOIN Data.Model AS MD ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
WHERE      (Color = 'Red' AND LineItemDiscount >= 1000 	
           AND (SalePrice - (Cost + RepairsCost + PartsCost 
                                         + TransportInCost)) > 5000) 
		   OR (PartsCost > 500 AND RepairsCost > 500)

