-- ==========================================================
--
--              CHAPTER 7
--
-- ==========================================================


-- 2

SELECT       SUM(Cost) AS TotalCost 
FROM         Data.Stock	


-- 3

SELECT        SUM(ST.Cost) AS TotalCost
             ,SUM(SD.SalePrice) AS TotalSales 
             ,SUM(SD.SalePrice) - SUM(ST.Cost) AS GrossProfit
FROM         Data.Stock ST	
INNER JOIN   Data.SalesDetails SD	
             ON ST.StockCode = SD.StockID


-- 4

SELECT     ModelName, SUM(Cost) AS TotalCost
FROM       Data.Stock ST
INNER JOIN Data.Model MD ON MD.ModelID = ST.ModelID
GROUP BY   ModelName


-- 5

SELECT     MakeName, ModelName, SUM(Cost) AS TotalCost
FROM       Data.Stock ST
INNER JOIN Data.Model MD ON MD.ModelID = ST.ModelID
INNER JOIN Data.Make AS MK ON MK.MakeID = MD.MakeID
GROUP BY   MakeName, ModelName	


-- 6

SELECT     MakeName, ModelName
           ,AVG(ST.Cost) AS AverageCost 
FROM       Data.Make AS MK 
INNER JOIN Data.Model AS MD ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
GROUP BY   MakeName, ModelName	


-- 7

SELECT       MakeName, ModelName 
            ,COUNT(SalesDetailsID) AS NumberofCarsSold
FROM        Data.Make AS MK 
INNER JOIN  Data.Model AS MD ON MK.MakeID = MD.MakeID
INNER JOIN  Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN  Data.SalesDetails SD ON ST.StockCode = SD.StockID
GROUP BY    MakeName, ModelName		
ORDER BY    MakeName, ModelName


-- 8

SELECT  COUNT(DISTINCT CountryName) AS CountriesWithSales
FROM    Data.SalesByCountry	


-- 9

SELECT       ModelName
            ,MAX(SalePrice) AS TopSalePrice
            ,MIN(SalePrice) AS BottomSalePrice
FROM        Data.Make AS MK 	
INNER JOIN  Data.Model AS MD ON MK.MakeID = MD.MakeID
INNER JOIN  Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN  Data.SalesDetails SD ON ST.StockCode = SD.StockID
GROUP BY    ModelName


-- 10

SELECT      MakeName, COUNT(SalePrice) AS CarsSold
FROM        Data.Make AS MK 
INNER JOIN  Data.Model MD
            ON MK.MakeID = MD.MakeID
INNER JOIN  Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN  Data.SalesDetails SD ON ST.StockCode = SD.StockID
WHERE       ST.Color = 'Red'
GROUP BY    MakeName	


-- 11

SELECT     CountryName, COUNT(SalesDetailsID) AS NumberofCarsSold
FROM       Data.SalesByCountry
GROUP BY   CountryName			
HAVING     COUNT(SalesDetailsID) > 50	


-- 12

SELECT     CustomerName, COUNT(SD.SalesDetailsID) AS NumberofCarsSold
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
INNER JOIN Data.Sales AS SA ON SA.SalesID = SD.SalesID
INNER JOIN Data.Customer CU ON SA.CustomerID = CU.CustomerID
WHERE      (SD.SalePrice 	
            - (
                ST.Cost + ISNULL(ST.RepairsCost,0) + ST.PartsCost 
                + ST.TransportInCost)
               ) > 5000
GROUP BY   CustomerName
HAVING     COUNT(SD.SalesDetailsID) >= 3


-- 13

SELECT      TOP (3) MakeName
FROM        Data.Make AS MK 
INNER JOIN  Data.Model AS MD ON MK.MakeID = MD.MakeID
INNER JOIN  Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN  Data.SalesDetails SD ON ST.StockCode = SD.StockID
GROUP BY    MakeName		
ORDER BY    SUM(SalePrice) DESC

