-- ==========================================================
--
--              CHAPTER 8
--
-- ==========================================================


-- 2

SELECT     MakeName, ModelName
FROM       Data.Make AS MK 
INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST 	
           ON ST.ModelID = MD.ModelID	
WHERE      DateBought = '20150725'


-- 3

SELECT     MakeName, ModelName
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID		
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
WHERE      DateBought BETWEEN '2016-06-30' AND '2016-07-31'


-- 4

SELECT     SUM(Cost) 
           / DATEDIFF(d, '20150701', '20150815') AS AverageDailyPurchase
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
WHERE      DateBought BETWEEN '20150701' AND '20150815'	


-- 5

SELECT     SUM(Cost) 
           / DATEDIFF(m, '20150701', 20161231) AS AverageDailyPurchase
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
WHERE      DateBought BETWEEN '20150701' AND '20161231'


-- 6

SELECT     MakeName, ModelName
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID	
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
INNER JOIN Data.Sales AS SA ON SA.SalesID = SD.SalesID	
WHERE      CAST(SA.SaleDate AS DATE) = '20160228'


-- 7

SELECT     MakeName, ModelName, YEAR(SaleDate) AS YearOfSale 
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
INNER JOIN Data.Sales AS SA ON SA.SalesID = SD.SalesID
WHERE      YEAR(SaleDate) = 2015		
ORDER BY   MakeName, ModelName


-- 8

SELECT DISTINCT MakeName, ModelName, YEAR(SaleDate) AS YearOfSale
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
INNER JOIN Data.Sales AS SA ON SA.SalesID = SD.SalesID	
WHERE      YEAR(SaleDate) IN (2015, 2016)	
ORDER BY   YEAR(SaleDate), MakeName, ModelName


-- 9

SELECT     MakeName, ModelName
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
INNER JOIN Data.Sales AS SA ON SA.SalesID = SD.SalesID
WHERE      YEAR(SaleDate) = 2015 		
           AND MONTH(SaleDate) = 7


-- 10

SELECT     MakeName, ModelName
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
INNER JOIN Data.Sales AS SA ON SA.SalesID = SD.SalesID
WHERE      DATEPART(q, SaleDate) = 3	
           AND YEAR(SA.SaleDate) = 2015	


-- 11

SELECT     MakeName, ModelName
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID	
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
INNER JOIN Data.Sales AS SA ON SA.SalesID = SD.SalesID
WHERE      DATEPART(dw, SA.SaleDate) = 6	
           AND YEAR(SA.SaleDate) = 2016


-- 12

SELECT     MakeName, ModelName
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
INNER JOIN Data.Sales AS SA ON SA.SalesID = SD.SalesID
WHERE      DATEPART(wk, SA.SaleDate) = 26		
           AND YEAR(SA.SaleDate) = 2017


-- 13

SELECT      DATEPART(dw, SaleDate) AS DayOfWeek
           ,SUM(SD.SalePrice) AS Sales
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
INNER JOIN Data.Sales AS SA ON SA.SalesID = SD.SalesID
WHERE      YEAR(SA.SaleDate) = 2015	
GROUP BY   DATEPART(dw, SA.SaleDate)
ORDER BY   SUM(SD.SalePrice) DESC


-- 14

SELECT      DATENAME(dw, SA.SaleDate) AS DayOfWeek
           ,SUM(SD.SalePrice) AS Sales
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
INNER JOIN Data.Sales AS SA ON SA.SalesID = SD.SalesID
WHERE      YEAR(SA.SaleDate) = 2015	
GROUP BY   DATENAME(dw, SA.SaleDate)
           ,DATEPART(dw, SA.SaleDate)
ORDER BY   DATEPART(dw, SA.SaleDate)


-- 15

SELECT     SUM(SD.SalePrice) AS CumulativeJaguarSales
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
INNER JOIN Data.Sales AS SA ON SA.SalesID = SD.SalesID
WHERE      SA.SaleDate BETWEEN DATEADD(d, -90, '20170725') and '20170725'
           AND MakeName = 'Jaguar'


-- 16

SELECT     MakeName, SUM(SD.SalePrice) AS CumulativeSales
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
INNER JOIN Data.Sales AS SA ON SA.SalesID = SD.SalesID
WHERE      CAST(SA.SaleDate AS DATE)  
           BETWEEN DATEADD(m, -3, CAST(GETDATE() AS DATE))
           AND CAST(GETDATE() AS DATE) 
GROUP BY   MakeName	
ORDER BY   MakeName ASC	


-- 17

SELECT GETDATE()

