-- ==========================================================
--
--              CHAPTER 9
--
-- ==========================================================


-- 2

SELECT 'Customer: ' + CustomerName AS Customer
FROM   Data.Customer	


-- 3

SELECT 'Sold For:' + STR(SalePrice) 
FROM    Data.SalesDetails	


-- 4

SELECT CustomerName, Address1 + ' ' + Town + ' ' + PostCode AS FullAddress FROM   Data.Customer

-- 5

SELECT     MakeName + ', ' + ModelName AS MakeAndModel
           ,SUM(SalePrice) As TotalSold 
FROM       Data.Stock ST 
INNER JOIN Data.Model MD 
           ON ST.ModelID = MD.ModelID 
INNER JOIN Data.Make MK 	
           ON MD.MakeID = MK.MakeID 
INNER JOIN Data.SalesDetails SD 	
           ON ST.StockCode = SD.StockID 
INNER JOIN Data.Sales SA 
           ON SD.SalesID = SA.SalesID
GROUP BY   MakeName + ', ' + ModelName


-- 6

SELECT CustomerName, ISNULL(Address1, '') + ' ' + ISNULL(Town, '') + ' ' 
                     + ISNULL(PostCode, '') AS FullAddress 
FROM   Data.Customer


-- 7

SELECT     CONCAT('Sales: ', TotalSalePrice ,' GBP') AS SalePriceInPounds
FROM       Data.Sales	


-- 8

SELECT     UPPER(CustomerName) AS Customer
FROM       Data.Customer	


-- 9

SELECT     LOWER(ModelName) AS Model
FROM       Data.Model	


-- 10

SELECT     ModelName + ' (' + LEFT(MakeName, 3) + ')' AS MakeAndModel
FROM       Data.Make		
INNER JOIN Data.Model
ON         Make.MakeID = Model.MakeID


-- 11

SELECT     RIGHT(InvoiceNumber, 3) AS InvoiceSequenceNumber 
FROM       Data.Sales
ORDER BY   InvoiceSequenceNumber


-- 12

SELECT     SUBSTRING(InvoiceNumber, 4, 2) AS DestinationCountry 
FROM       Data.Sales


-- 13

SELECT     InvoiceNumber, TotalSalePrice
FROM       Data.Sales		
WHERE      LEFT(InvoiceNumber, 3) = 'EUR'


-- 14

SELECT     InvoiceNumber, SA.TotalSalePrice
FROM       Data.Make AS MK INNER JOIN Data.Model AS MD 
           ON MK.MakeID = MD.MakeID
           INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
           INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
           INNER JOIN Data.Sales AS SA ON SA.SalesID = SD.SalesID
WHERE      SUBSTRING(InvoiceNumber, 4, 2)  = 'FR'
           AND MakeCountry = 'ITA'	



