-- ==========================================================
--
--              CHAPTER 11
--
-- ==========================================================


-- 2

SELECT      Cost, RepairsCost, PartsCost
           ,IIF(PartsCost > RepairsCost, 'Cost Alert!', NULL) 
           AS CostAnalysis
FROM       Data.Stock


-- 3

SELECT     Cost, RepairsCost, PartsCost 
           ,IIF(
                LEN(BuyerComments) < 25
                ,BuyerComments
                ,LEFT(BuyerComments, 20) + ' ...'
               ) AS Comments
FROM       Data.Stock


-- 4


SELECT      Cost, RepairsCost, PartsCost 
           ,IIF(
                (SalePrice - 
                  (Cost + LineItemDiscount
                        + PartsCost
                        + ISNULL(RepairsCost, 0) 
                        + TransportInCost
                   )		
                 ) 	
                 < (SalePrice * 0.1) 
                 AND (RepairsCost * 2) > PartsCost
              ,'Warning!!'
              ,'OK'
               ) AS CostAlert
FROM       Data.Stock ST
           INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID


-- 5

SELECT      Cost, RepairsCost, PartsCost 
           ,IIF(
                 (SalePrice - 
                       (Cost + LineItemDiscount-PartsCost 
                        + RepairsCost + TransportInCost) 
                  ) < SalePrice * 0.1 
		   ,'Warning!!'
		   ,IIF(	
                     (SalePrice - 
                         (Cost + LineItemDiscount-PartsCost 
                          + RepairsCost + TransportInCost) 
                      ) < SalePrice * 0.5, 'Acceptable', 'OK'
                    )
		   ) AS CostAlert
FROM       Data.Stock ST
           INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID


-- 6

SELECT     CountryName
           ,CASE CountryName
		   WHEN 'Belgium' THEN 'Eurozone'
		   WHEN 'France' THEN 'Eurozone'
		   WHEN 'Italy' THEN 'Eurozone'
		   WHEN 'Spain' THEN 'Eurozone'
		   WHEN 'United Kingdom' THEN 'Pound Sterling'
		   WHEN 'United States' THEN 'Dollar'
		   ELSE 'Other'
           END AS CurrencyRegion
FROM       Data.Country	


-- 7

SELECT    CASE 
               WHEN MakeCountry IN ('ITA', 'GER', 'FRA') THEN 'European'
               WHEN MakeCountry = 'GBR' THEN 'British'
               WHEN MakeCountry = 'USA' THEN 'American'
			   ELSE 'Other'
          END AS SalesRegion
          ,COUNT(SD.SalesDetailsID) AS NumberOfSales
FROM       Data.Make AS MK INNER JOIN Data.Model 
           AS MD ON MK.MakeID = MD.MakeID
           INNER JOIN Data.Stock AS ST ON ST.ModelID = MD.ModelID
           INNER JOIN Data.SalesDetails SD ON ST.StockCode = SD.StockID
GROUP BY   CASE 
               WHEN MakeCountry IN ('ITA', 'GER', 'FRA') THEN 'European'
               WHEN MakeCountry = 'GBR' THEN 'British'
               WHEN MakeCountry = 'USA' THEN 'American'
               ELSE 'Other'
          END	


-- 8

SELECT    CustomerName
          ,CASE
          WHEN IsReseller = 0 AND Country IN ('IT', 'DE', 'FR', 'ES', 'BE') 
                  THEN 'Eurozone Retail Client'
          WHEN IsReseller = 0 AND Country IN ('GB') 
                  THEN 'British Retail Client'
          WHEN IsReseller = 0 AND Country IN ('US') 
                  THEN 'American Retail Client'
          WHEN IsReseller = 0 AND Country IN ('CH') 
                  THEN 'Swiss Retail Client'
          WHEN IsReseller = 1 AND Country IN ('IT', 'DE', 'FR', 'ES', 'BE') 
                  THEN 'Eurozone Reseller'
          WHEN IsReseller = 1 AND Country IN ('GB') 
                  THEN 'British Reseller'
          WHEN IsReseller = 1 AND Country IN ('US') 
                  THEN 'American Reseller'
          WHEN IsReseller = 1 AND Country IN ('CH') 
                  THEN 'Swiss Reseller'
         END AS CustomerType
FROM       Data.Customer


-- 9

SELECT     CustomerName
           ,CASE
               WHEN IsCreditRisk = 0 THEN
			      CASE 
				    WHEN Country IN ('IT', 'DE', 'FR', 'ES', 'BE') 
                                THEN 'Eurozone No Risk'
					WHEN Country IN ('GB') 
                                THEN 'British No Risk'
			        WHEN Country IN ('US') 
                                THEN 'American No Risk'
			        WHEN Country IN ('CH') 
                                THEN 'Swiss No Risk'
				  END
               WHEN IsCreditRisk = 1 THEN
			      CASE
				    WHEN Country IN ('IT', 'DE', 'FR', 'ES', 'BE') 
                               THEN 'Eurozone Credit Risk'
					WHEN Country IN ('GB') 
                               THEN 'British Credit Risk'
			        WHEN Country IN ('US') 
                            THEN 'American Credit Risk'
			        WHEN Country IN ('CH') 
                            THEN 'Swiss Credit Risk'
                  END        
            END AS RiskType
FROM       Data.Customer


-- 10

SELECT      *
FROM        Data.SalesByCountry
ORDER BY    CASE WHEN LineItemDiscount IS NULL THEN 1 ELSE 0 END
            ,LineItemDiscount	


-- 11

SELECT     
MONTH(SaleDate) AS MonthNumber
,CHOOSE(MONTH(SaleDate), 'Winter', 'Winter', 'Spring', 'Spring', 'Summer', 'Summer','Summer','Summer','Autumn','Autumn', 'Winter','Winter') AS SalesSeason
FROM       Data.Sales

